-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use work.ImPack.all;

-- Entity ClkDiv --------------------------------------------------------------

entity TFFE is
  port (
    Reset : in std_logic;               -- Reset, low-aktiv
    ClkIn : in std_logic;               -- Takt FPGA-Board
    ClkOut    : out std_logic);                               --
end TFFE;


architecture TFFA of TFFE is    
Signal ClkOutS : std_logic;  

begin
   process (Reset, ClkIn)
	begin
	  if Reset = '0' then
	    ClkOutS <='0';
	  elsif ClkIn='1' and ClkIn'event then
	    ClkOutS<=not ClkOutS;
	  end if;
	end process;
	ClkOut<=ClkOutS;
end TFFA;

-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use work.ImPack.all;

-- Entity ClkDiv --------------------------------------------------------------

entity ClkDivE is
  port (
    Reset : in std_logic;               -- Reset, low-aktiv
    Clk25 : in std_logic;               -- Takt FPGA-Board
    ClkDiv    : inout std_logic_vector(CNDiv downto 0));                              
end ClkDivE;

architecture ClkDivA of ClkDivE is    

  component TFFE is
     port (
    Reset : in std_logic;               -- Reset, low-aktiv
    ClkIn : in std_logic;               -- Takt FPGA-Board
    ClkOut: out std_logic);

  end component;
  
begin
ClkDiv(0) <= Clk25;
  g: for i in 0 to CNDiv-1 generate
       TFFI: TFFE
       port map (Reset, ClkDiv(i), ClkDiv(i+1));   
     end generate;  
end ClkDivA;



